#!/usr/bin/python

# This program will combine a structure factor file generated by CTFIT
# with the 'save 1 column' command, saving column 11, with a 2 column
# structure factor file at high resolution. This requires that
# the data sets have been fit so the calculated structure factor matches
# well at low spatial frequencies.

# note the ctfit file contains amplitudes, the high res sf file 
# contains intensities, and the output contains intensities

# sfmerge.py <ctfit file> <high res sf> <cutoff S> <output>

import os
import sys
import string
from sys import argv

if (len(argv)<5):
	print "sfmerge.py <ctfit file> <high res sf> <cutoff S> <output>"
	sys.exit(1)

ssplit=float(argv[3])

fin=file(argv[1],"r")
lines=fin.readlines()
fin.close()

# read ctfit file and calculate min value at each s
vals=[]
for i in lines:
	s=string.split(i)
	if (float(s[0])>=ssplit) : break
	s=map ((lambda x: float(x)),s)
	vals.append([s[0],min(s[1:])**2])

# read appropriate part of high res sf file	
vals2=[]
fin=file(argv[2],"r")
lines=fin.readlines()
fin.close()
for i in lines:
	s=string.split(i)
	if (float(s[0])<=ssplit) : continue
	vals2.append([float(s[0]),float(s[1])])

# rescale 1st half
scale=vals2[0][1]/vals[len(vals)-1][1]
vals=map((lambda x: [x[0],x[1]*scale]),vals)

out=file(argv[4],"w")
for i in vals:
	out.write("%1.5f\t%1.5f\n"%(i[0],i[1]))
	
for i in vals2:
	out.write("%1.5f\t%1.5f\n"%(i[0],i[1]))
	
